// outputs
varying vec3 normal;
varying vec3 incident;

// uniform inputs
uniform vec3 eyePos;
uniform vec4 displace;
uniform mat4 mat4viewInverse;

void main() {
	// deformation
	float deformation = sin(gl_Vertex.y * displace.x + displace.y) * displace.z;
	vec4 position = (gl_Vertex + vec4(gl_Normal, 1.0) * deformation);

	normal = gl_Normal;

	vec4 worldPos = position;

	vec4 worldEyePos = vec4(eyePos,1.0);
			
	// calculate incident vector
	incident = worldPos.xyz - worldEyePos.xyz;
				
	// output position
	gl_Position = gl_ModelViewProjectionMatrix * position;
}
